/* eslint-disable max-classes-per-file */
import CodeMessages from '../interfaces/CodeMessages';

namespace Exceptions {
  export class BusinessError extends Error {
    record_id: string;

    code: string;

    constructor(code_messages_interface: CodeMessages) {
      super(`BusinessError: ${code_messages_interface.message}`);
      this.name = 'BusinessError';
      this.code = code_messages_interface.code;
      this.record_id = code_messages_interface.record_id;
      this.message = code_messages_interface.message;
    }
  }

  export class NotFoundError extends Error {
    statusCode: number;

    code: string;

    constructor(code_messages_interface: CodeMessages) {
      super(`NotFoundError: ${code_messages_interface.message}`);
      this.code = code_messages_interface.code;
      this.name = 'NotFoundError';
      this.message = code_messages_interface.message;
    }
  }
}

export default Exceptions;
