import { expect } from 'chai';

import ICompare from '../src/interfaces/ICompare';
import IOperator from '../src/interfaces/IOperators';
import OperatorValidator from '../src/index';

describe('Test suite - Comparator NUMBER', () => {
  it('SUCCESS: Number with operator EQUALS (TRUE)', () => {
    const trigger_value = 2021 as const;
    const value_of_compared = 2021 as const;
    const type_of_compared = typeof value_of_compared as ICompare;
    const operator = 'EQUALS';
    const comparator = new OperatorValidator(type_of_compared, value_of_compared, trigger_value, operator);
    const response = comparator.compare();
    expect(response).to.equal(true);
  });

  it('SUCCESS: Number with operator DIFF (TRUE)', () => {
    const trigger_value = 2021 as const;
    const value_of_compared = 2022 as const;
    const type_of_compared = typeof value_of_compared as ICompare;
    const operator = 'DIFF';
    const comparator = new OperatorValidator(type_of_compared, value_of_compared, trigger_value, operator);
    const response = comparator.compare();
    expect(response).to.equal(true);
  });

  it('SUCCESS: Number with comparator BIGGER (TRUE)', () => {
    const trigger_value = 2021 as const;
    const value_of_compared = 2022 as const;
    const type_of_compared = typeof value_of_compared as ICompare;
    const operator = 'BIGGER';
    const comparator = new OperatorValidator(type_of_compared, value_of_compared, trigger_value, operator);
    const response = comparator.compare();
    expect(response).to.equal(true);
  });

  it('SUCCESS: Number with comparator MINOR (TRUE)', () => {
    const trigger_value = 2021 as const;
    const value_of_compared = 2020 as const;
    const type_of_compared = typeof value_of_compared as ICompare;
    const operator = 'MINOR';
    const comparator = new OperatorValidator(type_of_compared, value_of_compared, trigger_value, operator);
    const response = comparator.compare();
    expect(response).to.equal(true);
  });

  it('SUCCESS: Number with comparator BIGGEREQ (TRUE)', () => {
    const trigger_value = 2021 as const;
    const value_of_compared = 2021 as const;
    const type_of_compared = typeof value_of_compared as ICompare;
    const operator = 'BIGGEREQ';
    const comparator = new OperatorValidator(type_of_compared, value_of_compared, trigger_value, operator);
    const response = comparator.compare();
    expect(response).to.equal(true);
  });

  it('SUCCESS: Number with comparator MINOREQ (TRUE)', () => {
    const trigger_value = 2021 as const;
    const value_of_compared = 2021 as const;
    const type_of_compared = typeof value_of_compared as ICompare;
    const operator = 'MINOREQ';
    const comparator = new OperatorValidator(type_of_compared, value_of_compared, trigger_value, operator);
    const response = comparator.compare();
    expect(response).to.equal(true);
  });

  it('SUCCESS: Number with comparator IN (TRUE)', () => {
    const value = 2021 as const;
    const value_to_compare = [2021, 2022] as const;
    const type_of_compared = typeof value as ICompare;
    const operator = 'IN';
    const comparator = new OperatorValidator(type_of_compared, value, value_to_compare, operator);
    const response = comparator.compare();
    expect(response).to.equal(true);
  });

  it('SUCCESS: Number with comparator NOT_IN (TRUE)', () => {
    const value_to_compare = [2020,2022] as const;
    const value = 2021 as const;
    const type_of_compared = typeof value as ICompare;
    const operator = 'NOT_IN';
    const comparator = new OperatorValidator(type_of_compared, value, value_to_compare, operator);
    const response = comparator.compare();
    expect(response).to.equal(true);
  });

  it('SUCCESS: Number with operator EQUALS (FALSE)', () => {
    const trigger_value = 2021 as const;
    const value_of_compared = 2020 as const;
    const type_of_compared = typeof value_of_compared as ICompare;
    const operator = 'EQUALS';
    const comparator = new OperatorValidator(type_of_compared, value_of_compared, trigger_value, operator);
    const response = comparator.compare();
    expect(response).to.equal(false);
  });

  it('SUCCESS: Number with operator DIFF (FALSE)', () => {
    const trigger_value = 2021 as const;
    const value_of_compared = 2021 as const;
    const type_of_compared = typeof value_of_compared as ICompare;
    const operator = 'DIFF';
    const comparator = new OperatorValidator(type_of_compared, value_of_compared, trigger_value, operator);
    const response = comparator.compare();
    expect(response).to.equal(false);
  });

  it('SUCCESS: Number with comparator BIGGER (FALSE)', () => {
    const trigger_value = 2021 as const;
    const value_of_compared = 2020 as const;
    const type_of_compared = typeof value_of_compared as ICompare;
    const operator = 'BIGGER';
    const comparator = new OperatorValidator(type_of_compared, value_of_compared, trigger_value, operator);
    const response = comparator.compare();
    expect(response).to.equal(false);
  });

  it('SUCCESS: Number with comparator MINOR (FALSE)', () => {
    const trigger_value = 2021 as const;
    const value_of_compared = 2022 as const;
    const type_of_compared = typeof value_of_compared as ICompare;
    const operator = 'MINOR';
    const comparator = new OperatorValidator(type_of_compared, value_of_compared, trigger_value, operator);
    const response = comparator.compare();
    expect(response).to.equal(false);
  });
  it('SUCCESS: Number with comparator BIGGEREQ (FALSE)', () => {
    const trigger_value = 2021 as const;
    const value_of_compared = 2020 as const;
    const type_of_compared = typeof value_of_compared as ICompare;
    const operator = 'BIGGEREQ';
    const comparator = new OperatorValidator(type_of_compared, value_of_compared, trigger_value, operator);
    const response = comparator.compare();
    expect(response).to.equal(false);
  });

  it('SUCCESS: Number with comparator MINOREQ (FALSE)', () => {
    const trigger_value = 2021 as const;
    const value_of_compared = 2022 as const;
    const type_of_compared = typeof value_of_compared as ICompare;
    const operator = 'MINOREQ';
    const comparator = new OperatorValidator(type_of_compared, value_of_compared, trigger_value, operator);
    const response = comparator.compare();
    expect(response).to.equal(false);
  });

  it('SUCCESS: Number with comparator IN (FALSE)', () => {
    const trigger_value = [2021] as const;
    const value_of_compared = 2022 as const;
    const type_of_compared = typeof value_of_compared as ICompare;
    const operator = 'IN';
    const comparator = new OperatorValidator(type_of_compared, value_of_compared, trigger_value, operator);
    const response = comparator.compare();
    expect(response).to.equal(false);
  });

  it('SUCCESS: Number with comparator NOT_IN (FALSE)', () => {
    const trigger_value = [2021] as const;
    const value_of_compared = 2021 as const;
    const type_of_compared = typeof value_of_compared as ICompare;
    const operator = 'NOT_IN';
    const comparator = new OperatorValidator(type_of_compared, value_of_compared, trigger_value, operator);
    const response = comparator.compare();
    expect(response).to.equal(false);
  });

  it('SUCCESS: Testing undefined OPERATOR', () => {
    const trigger_value = 2020 as const;
    const value_of_compared = 2020 as const;
    const type_of_compared = typeof value_of_compared as ICompare;
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    const operator = undefined as any as IOperator;
    const comparator = new OperatorValidator(type_of_compared, value_of_compared, trigger_value, operator);
    const response = comparator.compare();
    expect(response).to.equal(true);
  });

  it('SUCCESS: Testing DEFAULT case', () => {
    const trigger_value = 2021 as const;
    const value_of_compared = 2021 as const;
    const type_of_compared = typeof value_of_compared as ICompare;
    const operator = 'DEFAULT' as IOperator;
    const comparator = new OperatorValidator(type_of_compared, value_of_compared, trigger_value, operator);
    // eslint-disable-next-line dot-notation
    const response = comparator['compare']();
    expect(response).to.equal(false);
  });

  it('ERROR: Number with operator STARTING', () => {
    const trigger_value = 2021 as const;
    const value_of_compared = 20 as const;
    const type_of_compared = typeof value_of_compared as ICompare;
    const operator = 'STARTING';
    const comparator = new OperatorValidator(type_of_compared, value_of_compared, trigger_value, operator);
    const response = comparator.compare();
    expect(response).to.equal(false);
  });

  it('ERROR: Number with comparator ENDING', () => {
    const journey_value = 2021 as const;
    const behavior_value = 21 as const;
    const type_of_behavior_value = typeof behavior_value as ICompare;
    const operator = 'ENDING';
    const comparator = new OperatorValidator(type_of_behavior_value, behavior_value, journey_value, operator);
    const response = comparator.compare();
    expect(response).to.equal(false);
  });

  it('ERROR: Number with comparator HAS_DAY', () => {
    const journey_value = 2021 as const;
    const behavior_value = 21 as const;
    const type_of_behavior_value = typeof behavior_value as ICompare;
    const operator = 'HAS_DAY';
    const comparator = new OperatorValidator(type_of_behavior_value, behavior_value, journey_value, operator);
    const response = comparator.compare();
    expect(response).to.equal(false);
  });

  it('ERROR: Number with comparator HAS_MONTH', () => {
    const trigger_value = 2021 as const;
    const value_of_compared = 21 as const;
    const type_of_compared = typeof value_of_compared as ICompare;
    const operator = 'HAS_MONTH';
    const comparator = new OperatorValidator(type_of_compared, value_of_compared, trigger_value, operator);
    const response = comparator.compare();
    expect(response).to.equal(false);
  });

  it('ERROR: Number with comparator HAS_YEAR', () => {
    const journey_value = 2021 as const;
    const behavior_value = 21 as const;
    const type_of_behavior_value = typeof behavior_value as ICompare;
    const operator = 'HAS_YEAR';
    const comparator = new OperatorValidator(type_of_behavior_value, behavior_value, journey_value, operator);
    const response = comparator.compare();
    expect(response).to.equal(false);
  });
});
