/* eslint-disable dot-notation */
import { expect } from 'chai';

import CODE_MESSAGES from '../src/constants/codeMessages';
import DateComparatorHelper from '../src/utils/date_comparator';

const day = '26';
const month = '01';
const year = '2022';
const hyphen_string_date = [year, month, day].join('-');
const date_to_compare = new Date(hyphen_string_date);
const datetime_to_compare = date_to_compare.getTime();

describe('Test suite - Date Comparator', () => {
  it('SUCCESS: Check Date Type (date | HAS_DAY | typeof trigger_value == string)', () => {
    const date_comparator_helper = new DateComparatorHelper('HAS_DAY', date_to_compare, hyphen_string_date);

    expect(date_comparator_helper.type_of).to.equal('date');
    expect(date_comparator_helper.secondary_value_to_compare).to.equal(Number(day));
    expect(date_comparator_helper.primary_value_to_compare).to.equal(date_to_compare);
  });

  it('SUCCESS: Check Date Type (date | HAS_DAY | typeof trigger_value == number)', () => {
    const date_comparator_helper = new DateComparatorHelper('HAS_DAY', date_to_compare, Number(day));

    expect(date_comparator_helper.type_of).to.equal('date');
    expect(date_comparator_helper.secondary_value_to_compare).to.equal(Number(day));
    expect(date_comparator_helper.primary_value_to_compare).to.equal(date_to_compare);
  });

  it('SUCCESS: Check Date Type (date | HAS_MONTH | typeof trigger_value == string)', () => {
    const date_comparator_helper = new DateComparatorHelper('HAS_MONTH', date_to_compare, hyphen_string_date);

    expect(date_comparator_helper.type_of).to.equal('date');
    expect(date_comparator_helper.secondary_value_to_compare).to.equal(Number(month));
    expect(date_comparator_helper.primary_value_to_compare).to.equal(date_to_compare);
  });

  it('SUCCESS: Check Date Type (date | HAS_MONTH | typeof trigger_value == number)', () => {
    const date_comparator_helper = new DateComparatorHelper('HAS_MONTH', date_to_compare, Number(month));

    expect(date_comparator_helper.type_of).to.equal('date');
    expect(date_comparator_helper.secondary_value_to_compare).to.equal(Number(month));
    expect(date_comparator_helper.primary_value_to_compare).to.equal(date_to_compare);
  });

  it('SUCCESS: Check Date Type (date | HAS_YEAR | typeof trigger_value == string)', () => {
    const date_comparator_helper = new DateComparatorHelper('HAS_YEAR', date_to_compare, hyphen_string_date);

    expect(date_comparator_helper.type_of).to.equal('date');
    expect(date_comparator_helper.secondary_value_to_compare).to.equal(Number(year));
    expect(date_comparator_helper.primary_value_to_compare).to.equal(date_to_compare);
  });

  it('SUCCESS: Check Date Type (date | HAS_YEAR | typeof trigger_value == number)', () => {
    const date_comparator_helper = new DateComparatorHelper('HAS_YEAR', date_to_compare, Number(year));

    expect(date_comparator_helper.type_of).to.equal('date');
    expect(date_comparator_helper.secondary_value_to_compare).to.equal(Number(year));
    expect(date_comparator_helper.primary_value_to_compare).to.equal(date_to_compare);
  });

  it('SUCCESS: Check Date Type (datetime | BIGGER | typeof trigger_value == string)', () => {
    const date_comparator_helper = new DateComparatorHelper('BIGGER', date_to_compare, hyphen_string_date);

    expect(date_comparator_helper.type_of).to.equal('datetime');
    expect(date_comparator_helper.secondary_value_to_compare).to.equal(datetime_to_compare);
    expect(date_comparator_helper.primary_value_to_compare).to.equal(datetime_to_compare);
  });

  it('SUCCESS: Check Date Type (datetime | BIGGER | typeof trigger_value == number)', () => {
    const date_comparator_helper = new DateComparatorHelper('BIGGER', date_to_compare, datetime_to_compare);

    expect(date_comparator_helper.type_of).to.equal('datetime');
    expect(date_comparator_helper.secondary_value_to_compare).to.equal(datetime_to_compare);
    expect(date_comparator_helper.primary_value_to_compare).to.equal(datetime_to_compare);
  });

  it('SUCCESS: Check Date Type (datetime | MINOR | typeof trigger_value == string)', () => {
    const date_comparator_helper = new DateComparatorHelper('MINOR', date_to_compare, hyphen_string_date);

    expect(date_comparator_helper.type_of).to.equal('datetime');
    expect(date_comparator_helper.secondary_value_to_compare).to.equal(datetime_to_compare);
    expect(date_comparator_helper.primary_value_to_compare).to.equal(datetime_to_compare);
  });

  it('SUCCESS: Check Date Type (datetime | MINOR | typeof trigger_value == number)', () => {
    const date_comparator_helper = new DateComparatorHelper('MINOR', date_to_compare, datetime_to_compare);

    expect(date_comparator_helper.type_of).to.equal('datetime');
    expect(date_comparator_helper.secondary_value_to_compare).to.equal(datetime_to_compare);
    expect(date_comparator_helper.primary_value_to_compare).to.equal(datetime_to_compare);
  });

  it('SUCCESS: Check Date Type (datetime | BIGGEREQ | typeof trigger_value == string)', () => {
    const date_comparator_helper = new DateComparatorHelper('BIGGEREQ', date_to_compare, hyphen_string_date);

    expect(date_comparator_helper.type_of).to.equal('datetime');
    expect(date_comparator_helper.secondary_value_to_compare).to.equal(datetime_to_compare);
    expect(date_comparator_helper.primary_value_to_compare).to.equal(datetime_to_compare);
  });

  it('SUCCESS: Check Date Type (datetime | BIGGEREQ | typeof trigger_value == number)', () => {
    const date_comparator_helper = new DateComparatorHelper('BIGGEREQ', date_to_compare, datetime_to_compare);

    expect(date_comparator_helper.type_of).to.equal('datetime');
    expect(date_comparator_helper.secondary_value_to_compare).to.equal(datetime_to_compare);
    expect(date_comparator_helper.primary_value_to_compare).to.equal(datetime_to_compare);
  });

  it('SUCCESS: Check Date Type (datetime | MINOREQ | typeof trigger_value == string)', () => {
    const date_comparator_helper = new DateComparatorHelper('MINOREQ', date_to_compare, hyphen_string_date);

    expect(date_comparator_helper.type_of).to.equal('datetime');
    expect(date_comparator_helper.secondary_value_to_compare).to.equal(datetime_to_compare);
    expect(date_comparator_helper.primary_value_to_compare).to.equal(datetime_to_compare);
  });

  it('SUCCESS: Check Date Type (datetime | MINOREQ | typeof trigger_value == number)', () => {
    const date_comparator_helper = new DateComparatorHelper('MINOREQ', date_to_compare, datetime_to_compare);

    expect(date_comparator_helper.type_of).to.equal('datetime');
    expect(date_comparator_helper.secondary_value_to_compare).to.equal(datetime_to_compare);
    expect(date_comparator_helper.primary_value_to_compare).to.equal(datetime_to_compare);
  });

  it('ERROR: Check Date Type (date |typeof trigger_value == string | trigger_value isn\'t in date format)', () => {
    let res;
    try {
      res = new DateComparatorHelper('HAS_DAY', date_to_compare, 'iclubs');
    } catch (e) {
      res = e;
    }
    expect(res.message).to.equal(CODE_MESSAGES.INVALID_TRIGGER_EVENT_VALUE.message);
  });

  it('ERROR: Check Date Type (datetime |typeof trigger_value == string | trigger_value isn\'t in date format)', () => {
    let res;
    try {
      res = new DateComparatorHelper('BIGGER', date_to_compare, 'iclubs');
    } catch (e) {
      res = e;
    }
    expect(res.message).to.equal(CODE_MESSAGES.INVALID_TRIGGER_EVENT_VALUE.message);
  });

  it('BRANCH: Set Trigger Value To Compare', () => {
    const date_comparator_helper = new DateComparatorHelper('HAS_DAY', date_to_compare, { test: 'x' });

    expect(date_comparator_helper.secondary_value_to_compare).to.equal(undefined);
  });

  it('BRANCH: String Trigger Value To Compare', () => {
    const date_comparator_helper = new DateComparatorHelper('EQUALS', date_to_compare, hyphen_string_date);
    date_comparator_helper['stringEventValueToCompare']();

    expect(date_comparator_helper.type_of).to.equal(undefined);
    expect(date_comparator_helper.primary_value_to_compare).to.equal(undefined);
    expect(date_comparator_helper.secondary_value_to_compare).to.equal(undefined);
  });

  it('BRANCH: Return Date Time Value', () => {
    const date_comparator_helper = new DateComparatorHelper('EQUALS', date_to_compare, hyphen_string_date);
    date_comparator_helper['returnDateValue'](new Date(Date.now()));

    expect(date_comparator_helper.type_of).to.equal(undefined);
    expect(date_comparator_helper.secondary_value_to_compare).to.equal(undefined);
    expect(date_comparator_helper.primary_value_to_compare).to.equal(undefined);
  });
});
