"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class DateString {
    constructor(value) {
        this.value = null;
        this.received_value = value;
        this.is_date_string();
        if (this.is_date)
            this.set_date_value();
    }
    is_date_string() {
        const regex_bar_date = new RegExp('^\\d{2}\\/\\d{2}\\/\\d{4}$');
        this.is_bar_date = regex_bar_date.test(this.received_value);
        const regex_hyphen_date = new RegExp('^\\d{4}-\\d{2}-\\d{2}$');
        this.is_hyphen_date = regex_hyphen_date.test(this.received_value);
        this.is_iso_date = this.checkIsoDate();
        this.is_date = this.is_bar_date || this.is_hyphen_date || this.is_iso_date;
    }
    checkIsoDate() {
        const regex_iso_date = new RegExp('^(\\d{4})-(\\d{2})-(\\d{2})T(\\d{2}):(\\d{2}):(\\d{2}).(\\d{3})Z$');
        const response = regex_iso_date.test(this.received_value);
        return response;
    }
    set_date_value() {
        if (this.is_bar_date) {
            this.set_bar_date();
            return;
        }
        if (this.is_hyphen_date) {
            this.set_hyphen_date();
            return;
        }
        if (this.is_iso_date) {
            this.value = new Date(this.received_value);
        }
    }
    set_bar_date() {
        const [day, month, year] = this.received_value.split('/');
        this.value = new Date([year, month, day].join('-'));
    }
    set_hyphen_date() {
        this.value = new Date(this.received_value);
    }
}
exports.default = DateString;
